#  Copyright (c) 2023. Davi Pereira dos Santos
#  This file is part of the hdict project.
#  Please respect the license - more about this in the section (*) below.
#
#  hdict is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  hdict is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with hdict.  If not, see <http://www.gnu.org/licenses/>.
#
#  (*) Removing authorship by any means, e.g. by distribution of derived
#  works or verbatim, obfuscated, compiled or rewritten versions of any
#  part of this work is illegal and it is unethical regarding the effort and
#  time spent here.
#

from hdict.appearance import BW, ANSI, HTML
from hdict.content.apply import apply
from hdict.content.default import default
from hdict.content.field import field
from hdict.content.sample import sample
from hdict.content.value import value
from hdict.hdict_ import hdict


class _:
    def __call__(self, *args, **kwargs):
        return apply(*args, **kwargs)

    def __getattr__(self, item):
        return field(item)

    def __getitem__(self, item):
        return sample(*item)


_ = _()
